import java.net.*;
import java.io.*;
JSONArray items;
String result;
PImage chicago;
PImage img;
int[][] imgPixels;
float sval = 1.0;
float nmx, nmy;
int res = 5;

void setup() {
  size(1031, 1672);
  result   = getUrlContents("http://www.divvybikes.com/stations/json");
  textAlign(CENTER, CENTER);
  chicago = loadImage("map3.jpg");
  imgPixels = new int[chicago.width][chicago.height];
  for (int i = 0; i < chicago.height; i++) {
    for (int j = 0; j < chicago.width; j++) {
      imgPixels[j][i] = chicago.get(j, i);
    }
  }
}


void draw() {
  background(127);
  nmx += (mouseX-nmx)/20; 
  nmy += (mouseY-nmy)/20; 

  if (mousePressed) { 
    sval += 0.05;
  } else {
    sval -= 0.01;
  }

  sval = constrain(sval, 1.0, 2.0);

  translate(width/2 + nmx * sval-100, height/2 + nmy*sval - 100, -50);
  scale(sval);
  rotateZ(PI/9 - sval + 1.0);
  rotateX(PI/sval/8 - 0.125);
  rotateY(sval/8 - 0.125);

  translate(-width/2, -height/2, 0);


  image(chicago, 0, 0, width, height);
  result   = getUrlContents("http://www.divvybikes.com/stations/json");

  fill(255, 0, 0, 25);
  JSONObject stations = JSONObject.parse(result);
  JSONArray items = stations.getJSONArray("stationBeanList");


  for (int i = 0; i < items.size (); i++) {

    JSONObject stationInfo = items.getJSONObject(i); 

    String stationName = stationInfo.getString("stationName");
    int totalDocks = stationInfo.getInt("totalDocks");
    int availableBikes = stationInfo.getInt("availableBikes");
    float longitude = stationInfo.getFloat("longitude");
    float latitude = stationInfo.getFloat("latitude");
    //println(longitude+" "+latitude);    

    float lon = map(longitude, -87.7317, -87.6081, 0, width);
    float lat = map(latitude, 41.9278, 41.7792, 0, height);
    float diameter = availableBikes*2;

    float diameterScale = map(sval, .5, 1.5, 1, 0.5);
    diameter=diameter*diameterScale;


    println(sval);
    if (availableBikes < 10) {

      fill(59, 232, 255, 60);
      ellipse(lon, lat, diameter*2, diameter*2);
    } else if (availableBikes > 10) {

      fill(59, 232, 255, 100);
      ellipse(lon, lat, diameter*2, diameter*2);
    }
    //println(lat + ", " + lon + ", " + country);
  }
}

